# pyright: reportUnusedImport=false
import struct
from typing import Optional, Self, Sequence
from .. import abcs
from ..core import Request, serialize_bytes_to
_bytes = bytes | bytearray | memoryview
def update_profile_photo(*, fallback: bool, bot: Optional[abcs.InputUser], id: abcs.InputPhoto) -> Request[abcs.photos.Photo]:
    _buffer = bytearray(b'9 \xe8\t')
    flags = (1 if fallback else 0) | (0 if bot is None else 2)
    _buffer += struct.pack('<I', flags)
    if bot is not None:
      bot._write_boxed_to(_buffer)
    id._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def upload_profile_photo(*, fallback: bool, bot: Optional[abcs.InputUser], file: Optional[abcs.InputFile], video: Optional[abcs.InputFile], video_start_ts: Optional[float], video_emoji_markup: Optional[abcs.VideoSize]) -> Request[abcs.photos.Photo]:
    _buffer = bytearray(b'\xb5\xa3\x88\x03')
    flags = (8 if fallback else 0) | (0 if bot is None else 32) | (0 if file is None else 1) | (0 if video is None else 2) | (0 if video_start_ts is None else 4) | (0 if video_emoji_markup is None else 16)
    _buffer += struct.pack('<I', flags)
    if bot is not None:
      bot._write_boxed_to(_buffer)
    if file is not None:
      file._write_boxed_to(_buffer)
    if video is not None:
      video._write_boxed_to(_buffer)
    if video_start_ts is not None:
      _buffer += struct.pack(f'<d', video_start_ts)
    if video_emoji_markup is not None:
      video_emoji_markup._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def delete_photos(*, id: Sequence[abcs.InputPhoto]) -> Request[Sequence[int]]:
    _buffer = bytearray(b'/\x7f\xcf\x87')
    _buffer += struct.pack('<ii', 0x1cb5c415, len(id))
    for _t0 in id:
      _t0._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_user_photos(*, user_id: abcs.InputUser, offset: int, max_id: int, limit: int) -> Request[abcs.photos.Photos]:
    _buffer = bytearray(b'\xa82\xcd\x91')
    user_id._write_boxed_to(_buffer)
    _buffer += struct.pack('<iqi', offset, max_id, limit)
    return Request(b'' + _buffer)
def upload_contact_profile_photo(*, suggest: bool, save: bool, user_id: abcs.InputUser, file: Optional[abcs.InputFile], video: Optional[abcs.InputFile], video_start_ts: Optional[float], video_emoji_markup: Optional[abcs.VideoSize]) -> Request[abcs.photos.Photo]:
    _buffer = bytearray(b'qJL\xe1')
    flags = (8 if suggest else 0) | (16 if save else 0) | (0 if file is None else 1) | (0 if video is None else 2) | (0 if video_start_ts is None else 4) | (0 if video_emoji_markup is None else 32)
    _buffer += struct.pack('<I', flags)
    user_id._write_boxed_to(_buffer)
    if file is not None:
      file._write_boxed_to(_buffer)
    if video is not None:
      video._write_boxed_to(_buffer)
    if video_start_ts is not None:
      _buffer += struct.pack(f'<d', video_start_ts)
    if video_emoji_markup is not None:
      video_emoji_markup._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
